//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2008 - INRIA - Pierre MARECHAL
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function demo_fig=fsqp_demo_gui(path,name,img_size,methods)
	
// =========================================================================
  
  res_h= 100
  margin_x     = 5;      // Horizontal margin between each elements
  margin_y     = 5;      // Vertical margin between each elements
  button_w     = 100;
  button_h     = 30;
  list_w       = 180;
  list_h       = 20*size(methods,'*');
  axes_w      = img_size(1)+3*margin_x+max(button_w,list_w);     // Frame width
  axes_h      = img_size(2)+3*margin_y+res_h;     // Frame height
  
  defaultfont  = "arial"; // Default Font

  demo_fig = figure(100001);
  demo_fig.axes_size       = [axes_w axes_h];
  demo_fig.user_data       = [path;name]

  clf(demo_fig)
  // Remove Scilab graphics menus & toolbar
  
  delmenu(demo_fig.figure_id, gettext("&File"));
  delmenu(demo_fig.figure_id, gettext("&Tools"));
  delmenu(demo_fig.figure_id, gettext("&Edit"));
  delmenu(demo_fig.figure_id, gettext("&?"));
  toolbar(demo_fig.figure_id, "off");
  
  // Add the new one
  if %f then
    h = uimenu( "parent", demo_fig,          ..
		"label" , gettext("File"));
    
    uimenu( "parent"    , h,                 ..
	    "label"     , gettext("Close"),  ..
	    "callback"  , "demo_fig=get_figure_handle(100000);delete(demo_fig);", ..
	    "tag"       , "close_menu");
  end
  // Background, Resize, title ...
  
  demo_fig.background      = -2;
  demo_fig.figure_name     = gettext("Optimization problem");
  
  
  yo=axes_h-margin_y
  dlabel=uicontrol( ...
      "parent"              , demo_fig,...
      "style"               , "text",...
      "string"              , "The problem to solve",...
      "units"               , "pixels",...
      "position"            , [margin_x yo-20 img_size(1) 20],....
      "fontname"            , defaultfont,...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontWeight"          , "bold",...
      "horizontalalignment" , "center", ...
      "background"          , [1 1 1], ...
      "visible"             , "on", ...
      "tag"                 , "dlabel");
  yo=yo-margin_y-20
  desc=uicontrol( ...
      "parent"              , demo_fig,...
      "style"               , "text",...
      "string"              , "<html><img src=""file:///"+path+name+".png"" /></html>",...
      "units"               , "pixels",...
      "position"            , [margin_x yo-img_size(2) img_size],....
      "fontname"            , defaultfont,...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontWeight"          , "bold",...
      "horizontalalignment" , "left", ...
      "background"          , [0.8 0.8 0.8], ...
      "visible"             , "on", ...
      "tag"                 , "Description");
  yo=yo-margin_y-img_size(2)
  res=uicontrol( ...
      "parent"              , demo_fig,...
      "style"               , "text",...
      "Max"                 , 10,...
      "string"              , "",...
      "units"               , "pixels",...
      "position"            , [margin_x yo-res_h axes_w-2*margin_x res_h ],...
      "fontname"            , defaultfont,...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontWeight"          , "bold",...
      "horizontalalignment" , "left", ...
      "background"          , [1 1 1], ...
      "visible"             , "on", ...
      "tag"                 , "Result");

  // controls
  yo=axes_h-margin_y
  x=2*margin_x+img_size(1)
  clabel=uicontrol( ...
      "parent"              , demo_fig,...
      "style"               , "text",...
      "string"              , "Select problem description",...
      "units"               , "pixels",...
      "position"            , [x yo-20 list_w 20],....
      "fontname"            , defaultfont,...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontWeight"          , "bold",...
      "horizontalalignment" , "center", ...
      "background"          , [1 1 1], ...
      "visible"             , "on", ...
      "tag"                 , "clabel");
  yo=yo-margin_y-20
  meth=uicontrol( ...
      "parent"              , demo_fig,...
      "style"               , "listbox",...
      "string"              , " "+strcat(methods,"| "),...
      "units"               , "pixels",...
      "position"            , [x,yo-list_h list_w list_h],...
      "fontname"            , defaultfont,...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "horizontalalignment" , "left", ...
      "BackgroundColor"     , [1 1 1], ...
      "visible"             , "on", ...
      "value"               , 1, ...
      "user_data"           , [], ...
      "tag"                 , "listbox");

  
  // pushbutton creation
  yo=yo-margin_y-list_h
  view_button = uicontrol( ...
      "parent"              , demo_fig,...
      "relief"              , "groove",...
      "style"               , "pushbutton",...
      "string"              , gettext("View Code"),...
      "units"               , "pixels",...
      "position"            , [x yo-button_h button_w button_h],..
      "fontname"            , "arial",...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontweight"          , "bold", ...
      "horizontalalignment" , "center", ...
      "visible"             , "on", ...
      "callback"            , "fsqp_view_code()",...
      "tag"                 , "button_view_code" );
  yo=yo-margin_y-button_h
  run_button = uicontrol( ...
      "parent"              , demo_fig,...
      "relief"              , "groove",...
      "style"               , "pushbutton",...
      "string"              , gettext("Run code"),...
      "units"               , "pixels",...
      "position"            , [x yo-button_h  button_w button_h],..
      "fontname"            , "arial",...
      "fontunits"           , "points",...
      "fontsize"            , 12,...
      "fontweight"          , "bold", ...
      "horizontalalignment" , "center", ...
      "visible"             , "on", ...
      "callback"            , "fsqp_run_code()",...
      "tag"                 , "button_run_code" );
  
endfunction


function fsqp_view_code()
  demo_fig=scf(100001);
  data=demo_fig.user_data;
  ind=demo_fig.children(3).Value;
  scipad(data(1)+data(2)+'.'+string(ind)+'.sce')
endfunction

function fsqp_run_code()
  demo_fig=scf(100001);
  demo_fig.children(1).enable='off';
  data=demo_fig.user_data;
  ind=demo_fig.children(3).Value;

  
  exec(data(1)+data(2)+'.'+string(ind)+'.sce')
  demo_fig.children(1).enable='on';
endfunction

  
  
